--- old/usr/src/uts/common/inet/ip/sadb.c	Wed Jul  9 13:48:02 2014
+++ new/usr/src/uts/common/inet/ip/sadb.c	Wed Jul  9 13:48:02 2014
@@ -5479,204 +5716,179 @@
 /* End XXX label-library-leakage */
 
 /*
- * Construct an extended ACQUIRE message based on a selector and the resulting
- * IPsec action.
- *
- * NOTE: This is used by both inverse ACQUIRE and actual ACQUIRE
- * generation. As a consequence, expect this function to evolve
- * rapidly.
+ * Takes a pointer to sadb_prop_t (what we're initializing), ipsec_action_t
+ * (first action in chain we need to walk of actions for each alg
+ * combination), netstack_ns (contains pointers to alg properties and
+ * per-protocol settings), a combs_limit integer (maximum applicable
+ * combinations derived from per-protcol netstack_t alg array), and need_esp
+ * boolean_t. We distinguish between two error cases: we exceed combs_limit,
+ * which should only be a kernel bug (ipsec_alg_lock is our shepherd), or we
+ * have an alg ID with a NULL netstack member or member with the valid bit
+ * flipped, both of which indicate the needs to reset state, which we flag by
+ * returning no combs. We return NULL if we exceed combs_limit and zero-length
+ * prop if we run into an alg that can't be transferred into the prop.
  */
-static mblk_t *
-sadb_extended_acquire(ipsec_selector_t *sel, ipsec_policy_t *pol,
-    ipsec_action_t *act, boolean_t tunnel_mode, uint32_t seq, uint32_t pid,
-    sadb_sens_t *sens, netstack_t *ns)
+static void
+sadb_insert_prop(sadb_prop_t *prop, const ipsec_action_t *ap, netstack_t *ns,
+    uint_t combs_limit, boolean_t need_esp)
 {
-	mblk_t *mp;
-	sadb_msg_t *samsg;
-	uint8_t *start, *cur, *end;
-	uint32_t *saddrptr, *daddrptr;
-	sa_family_t af;
-	sadb_prop_t *eprop;
-	ipsec_action_t *ap, *an;
-	ipsec_selkey_t *ipsl;
-	uint8_t proto, pfxlen;
-	uint16_t lport, rport;
-	uint32_t kmp, kmc;
+	sadb_comb_t	*comb = (sadb_comb_t *)(prop + 1);
+	ipsec_action_t	*act = (ipsec_action_t *)ap;
+	ipsec_prot_t	*prot;
+	ipsecah_stack_t	*ahstack = ns->netstack_ipsecah;
+	ipsecesp_stack_t *espstack = ns->netstack_ipsecesp;
+	ipsec_stack_t	*ipss = ns->netstack_ipsec;
+	boolean_t	need_ah = !need_esp;
 
-	/*
-	 * Find the action we want sooner rather than later..
-	 */
-	an = NULL;
-	if (pol == NULL) {
-		ap = act;
-	} else {
-		ap = pol->ipsp_act;
+	ASSERT(RW_READ_HELD(&ipss->ipsec_alg_lock));
+	ASSERT((need_esp && ap->ipa_want_esp) || (need_ah && ap->ipa_want_ah));
 
-		if (ap != NULL)
-			an = ap->ipa_next;
-	}
+	prop->sadb_prop_exttype = SADB_EXT_PROPOSAL;
+	prop->sadb_prop_len = SADB_8TO64(sizeof (sadb_prop_t));
+	*(uint32_t *)(&prop->sadb_prop_replay) = 0; /* Quick zero-out! */
+	prop->sadb_prop_replay = need_esp ?
+	    espstack->ipsecesp_replay_size : ahstack->ipsecah_replay_size;
 
-	/*
-	 * Just take a swag for the allocation for now.	 We can always
-	 * alter it later.
-	 */
-#define	SADB_EXTENDED_ACQUIRE_SIZE	4096
-	mp = allocb(SADB_EXTENDED_ACQUIRE_SIZE, BPRI_HI);
-	if (mp == NULL)
-		return (NULL);
+	/* Prioritize a proposal, preserving policy order. */
+	for (; act != NULL; act = act->ipa_next) {
+		ipsec_alginfo_t *aalg = NULL;
+		ipsec_alginfo_t *ealg = NULL;
 
-	start = mp->b_rptr;
-	end = start + SADB_EXTENDED_ACQUIRE_SIZE;
+		if ((act->ipa_act.ipa_type != IPSEC_POLICY_APPLY) ||
+		    (need_esp && !act->ipa_act.ipa_apply.ipp_use_esp) ||
+		    (need_ah && !act->ipa_act.ipa_apply.ipp_use_ah))
+			continue;
 
-	cur = start;
+		if (--combs_limit == 0) {
+			prop = NULL;
+			return;
+		}
 
-	samsg = (sadb_msg_t *)cur;
-	cur += sizeof (*samsg);
+		prot = &act->ipa_act.ipa_apply;
 
-	samsg->sadb_msg_version = PF_KEY_V2;
-	samsg->sadb_msg_type = SADB_ACQUIRE;
-	samsg->sadb_msg_errno = 0;
-	samsg->sadb_msg_reserved = 0;
-	samsg->sadb_msg_satype = 0;
-	samsg->sadb_msg_seq = seq;
-	samsg->sadb_msg_pid = pid;
-
-	if (tunnel_mode) {
 		/*
-		 * Form inner address extensions based NOT on the inner
-		 * selectors (i.e. the packet data), but on the policy's
-		 * selector key (i.e. the policy's selector information).
-		 *
-		 * NOTE:  The position of IPv4 and IPv6 addresses is the
-		 * same in ipsec_selkey_t (unless the compiler does very
-		 * strange things with unions, consult your local C language
-		 * lawyer for details).
+		 * Alg ID 0 is none/any, which is valid only for ESP without
+		 * message integrity (ipp_esp_auth_alg). NULL encryption ESP
+		 * uses a distinct alg, non-zero ID.
 		 */
-		ASSERT(pol != NULL);
-
-		ipsl = &(pol->ipsp_sel->ipsl_key);
-		if (ipsl->ipsl_valid & IPSL_IPV4) {
-			af = AF_INET;
-			ASSERT(sel->ips_protocol == IPPROTO_ENCAP);
-			ASSERT(!(ipsl->ipsl_valid & IPSL_IPV6));
-		} else {
-			af = AF_INET6;
-			ASSERT(sel->ips_protocol == IPPROTO_IPV6);
-			ASSERT(ipsl->ipsl_valid & IPSL_IPV6);
+		if ((need_esp && prot->ipp_esp_auth_alg != 0) || need_ah) {
+			ASSERT(need_esp || (prot->ipp_auth_alg > 0));
+			aalg = ipss->ipsec_alglists[IPSEC_ALG_AUTH][need_esp ?
+			    prot->ipp_esp_auth_alg : prot->ipp_auth_alg];
+			if (aalg == NULL || !ALG_VALID(aalg))
+				goto failure;
 		}
 
-		if (ipsl->ipsl_valid & IPSL_LOCAL_ADDR) {
-			saddrptr = (uint32_t *)(&ipsl->ipsl_local);
-			pfxlen = ipsl->ipsl_local_pfxlen;
-		} else {
-			saddrptr = (uint32_t *)(&ipv6_all_zeros);
-			pfxlen = 0;
+		if (need_esp) {
+			ASSERT(prot->ipp_encr_alg > 0);
+			ealg = ipss->ipsec_alglists[IPSEC_ALG_ENCR]
+			    [prot->ipp_encr_alg];
+			if (ealg == NULL || !ALG_VALID(ealg))
+				goto failure;
 		}
-		/* XXX What about ICMP type/code? */
-		lport = (ipsl->ipsl_valid & IPSL_LOCAL_PORT) ?
-		    ipsl->ipsl_lport : 0;
-		proto = (ipsl->ipsl_valid & IPSL_PROTOCOL) ?
-		    ipsl->ipsl_proto : 0;
 
-		cur = sadb_make_addr_ext(cur, end, SADB_X_EXT_ADDRESS_INNER_SRC,
-		    af, saddrptr, lport, proto, pfxlen);
-		if (cur == NULL) {
-			freeb(mp);
-			return (NULL);
-		}
+		comb->sadb_comb_flags = 0;
+		comb->sadb_comb_reserved = 0;
 
-		if (ipsl->ipsl_valid & IPSL_REMOTE_ADDR) {
-			daddrptr = (uint32_t *)(&ipsl->ipsl_remote);
-			pfxlen = ipsl->ipsl_remote_pfxlen;
+		if (ealg != NULL) {
+			comb->sadb_comb_encrypt = ealg->alg_id;
+			comb->sadb_comb_encrypt_minbits =
+			    MAX(prot->ipp_espe_minbits, ealg->alg_ef_minbits);
+			comb->sadb_comb_encrypt_maxbits =
+			    MIN(prot->ipp_espe_maxbits, ealg->alg_ef_maxbits);
 		} else {
-			daddrptr = (uint32_t *)(&ipv6_all_zeros);
-			pfxlen = 0;
+			comb->sadb_comb_encrypt = 0;
+			comb->sadb_comb_encrypt_minbits = 0;
+			comb->sadb_comb_encrypt_maxbits = 0;
 		}
-		/* XXX What about ICMP type/code? */
-		rport = (ipsl->ipsl_valid & IPSL_REMOTE_PORT) ?
-		    ipsl->ipsl_rport : 0;
 
-		cur = sadb_make_addr_ext(cur, end, SADB_X_EXT_ADDRESS_INNER_DST,
-		    af, daddrptr, rport, proto, pfxlen);
-		if (cur == NULL) {
-			freeb(mp);
-			return (NULL);
+		if (aalg != NULL) {
+			uint16_t minbits, maxbits;
+			minbits = need_esp ?
+			    prot->ipp_espa_minbits : prot->ipp_ah_minbits;
+			maxbits = need_esp ?
+			    prot->ipp_espa_maxbits : prot->ipp_ah_maxbits;
+			comb->sadb_comb_auth = aalg->alg_id;
+			comb->sadb_comb_auth_minbits =
+			    MAX(minbits, aalg->alg_ef_minbits);
+			comb->sadb_comb_auth_maxbits =
+			    MIN(maxbits, aalg->alg_ef_maxbits);
+		} else {
+			comb->sadb_comb_auth = 0;
+			comb->sadb_comb_auth_minbits = 0;
+			comb->sadb_comb_auth_maxbits = 0;
 		}
+
 		/*
-		 * TODO  - if we go to 3408's dream of transport mode IP-in-IP
-		 * _with_ inner-packet address selectors, we'll need to further
-		 * distinguish tunnel mode here.  For now, having inner
-		 * addresses and/or ports is sufficient.
-		 *
-		 * Meanwhile, whack proto/ports to reflect IP-in-IP for the
-		 * outer addresses.
+		 * The following may be based on algorithm properties, but in
+		 * the meantime, we just pick some good, sensible numbers.
+		 * Key mgmt. can (and perhaps should) be the place to finalize
+		 * such decisions.
 		 */
-		proto = sel->ips_protocol;	/* Either _ENCAP or _IPV6 */
-		lport = rport = 0;
-	} else if ((ap != NULL) && (!ap->ipa_want_unique)) {
-		proto = 0;
-		lport = 0;
-		rport = 0;
-		if (pol != NULL) {
-			ipsl = &(pol->ipsp_sel->ipsl_key);
-			if (ipsl->ipsl_valid & IPSL_PROTOCOL)
-				proto = ipsl->ipsl_proto;
-			if (ipsl->ipsl_valid & IPSL_REMOTE_PORT)
-				rport = ipsl->ipsl_rport;
-			if (ipsl->ipsl_valid & IPSL_LOCAL_PORT)
-				lport = ipsl->ipsl_lport;
-		}
-	} else {
-		proto = sel->ips_protocol;
-		lport = sel->ips_local_port;
-		rport = sel->ips_remote_port;
-	}
 
-	af = sel->ips_isv4 ? AF_INET : AF_INET6;
+		/* 0 == unlimited == unsupported */
+		comb->sadb_comb_soft_allocations = 0;
+		comb->sadb_comb_hard_allocations = 0;
 
-	/*
-	 * NOTE:  The position of IPv4 and IPv6 addresses is the same in
-	 * ipsec_selector_t.
-	 */
-	cur = sadb_make_addr_ext(cur, end, SADB_EXT_ADDRESS_SRC, af,
-	    (uint32_t *)(&sel->ips_local_addr_v6), lport, proto, 0);
+		/* These may want to come from policy rule. */
+		if (need_esp) {
+			comb->sadb_comb_soft_bytes =
+			    espstack->ipsecesp_default_soft_bytes;
+			comb->sadb_comb_hard_bytes =
+			    espstack->ipsecesp_default_hard_bytes;
+			comb->sadb_comb_soft_addtime =
+			    espstack->ipsecesp_default_soft_addtime;
+			comb->sadb_comb_hard_addtime =
+			    espstack->ipsecesp_default_hard_addtime;
+			comb->sadb_comb_soft_usetime =
+			    espstack->ipsecesp_default_soft_usetime;
+			comb->sadb_comb_hard_usetime =
+			    espstack->ipsecesp_default_hard_usetime;
+		} else {
+			comb->sadb_comb_soft_bytes =
+			    ahstack->ipsecah_default_soft_bytes;
+			comb->sadb_comb_hard_bytes =
+			    ahstack->ipsecah_default_hard_bytes;
+			comb->sadb_comb_soft_addtime =
+			    ahstack->ipsecah_default_soft_addtime;
+			comb->sadb_comb_hard_addtime =
+			    ahstack->ipsecah_default_hard_addtime;
+			comb->sadb_comb_soft_usetime =
+			    ahstack->ipsecah_default_soft_usetime;
+			comb->sadb_comb_hard_usetime =
+			    ahstack->ipsecah_default_hard_usetime;
+		}
 
-	if (cur == NULL) {
-		freeb(mp);
-		return (NULL);
+		prop->sadb_prop_len += SADB_8TO64(sizeof (*comb));
+		comb++;
 	}
 
-	cur = sadb_make_addr_ext(cur, end, SADB_EXT_ADDRESS_DST, af,
-	    (uint32_t *)(&sel->ips_remote_addr_v6), rport, proto, 0);
+	return;
 
-	if (cur == NULL) {
-		freeb(mp);
-		return (NULL);
-	}
+failure:
+	prop->sadb_prop_len = 0;
+}
 
-	if (sens != NULL) {
-		uint8_t *sensext = cur;
-		int senslen = SADB_64TO8(sens->sadb_sens_len);
+/*
+ * Construct extended properties using ipsec_action_t, ipsec_policy_t, and
+ * netstack_t pointers. Byte-aligned pointers cur and end are used for bounds
+ * checking here and in called code. We don't set length if numecombs is 0, so
+ * callers must check this for error handling.
+ */
+static uint8_t *
+sadb_construct_eprop(const ipsec_action_t *act, const ipsec_policy_t *pp,
+    netstack_t *ns, const uint8_t *start, const uint8_t *end)
+{
+	uint8_t		*cur = (uint8_t *)start;
+	sadb_prop_t	*eprop = (sadb_prop_t *)cur;
+	ipsec_action_t	*an, *ap = (ipsec_action_t *)act;
+	ipsec_stack_t	*ipss = ns->netstack_ipsec;
 
-		cur += senslen;
-		if (cur > end) {
-			freeb(mp);
-			return (NULL);
-		}
-		bcopy(sens, sensext, senslen);
-	}
+	ASSERT(RW_READ_HELD(&ipss->ipsec_alg_lock));
 
-	/*
-	 * This section will change a lot as policy evolves.
-	 * For now, it'll be relatively simple.
-	 */
-	eprop = (sadb_prop_t *)cur;
 	cur += sizeof (*eprop);
-	if (cur > end) {
-		/* no space left */
-		freeb(mp);
+	if (cur > end)
 		return (NULL);
-	}
 
 	eprop->sadb_prop_exttype = SADB_X_EXT_EPROP;
 	eprop->sadb_x_prop_ereserved = 0;
@@ -5683,21 +5895,16 @@
 	eprop->sadb_x_prop_numecombs = 0;
 	eprop->sadb_prop_replay = 32;	/* default */
 
-	kmc = kmp = 0;
-
 	for (; ap != NULL; ap = an) {
-		an = (pol != NULL) ? ap->ipa_next : NULL;
-
 		/*
-		 * Skip non-IPsec policies
+		 * XXX Don't walk past first ap if there's no pp. Not clear on
+		 * the rationale for this, but it's what extended path did.
 		 */
+		an = (pp != NULL) ? ap->ipa_next : NULL;
+
 		if (ap->ipa_act.ipa_type != IPSEC_ACT_APPLY)
 			continue;
 
-		if (ap->ipa_act.ipa_apply.ipp_km_proto)
-			kmp = ap->ipa_act.ipa_apply.ipp_km_proto;
-		if (ap->ipa_act.ipa_apply.ipp_km_cookie)
-			kmc = ap->ipa_act.ipa_apply.ipp_km_cookie;
 		if (ap->ipa_act.ipa_apply.ipp_replay_depth) {
 			eprop->sadb_prop_replay =
 			    ap->ipa_act.ipa_apply.ipp_replay_depth;
@@ -5704,164 +5911,211 @@
 		}
 
 		cur = sadb_action_to_ecomb(cur, end, ap, ns);
-		if (cur == NULL) { /* no space */
-			freeb(mp);
+		if (cur == NULL)
 			return (NULL);
-		}
 		eprop->sadb_x_prop_numecombs++;
 	}
 
-	if (eprop->sadb_x_prop_numecombs == 0) {
+	/*
+	 * This is an error. We return what we've got of eprops, caller needs
+	 * to check for condition and pass it further up (e.g. by error samsg).
+	 */
+	if (eprop->sadb_x_prop_numecombs == 0)
+		return (cur);
+
+	eprop->sadb_prop_len = SADB_8TO64(cur - (uint8_t *)start);
+
+	return (cur);
+bail:
+	return (NULL);
+}
+
+/*
+ * Convert ipsec_policy_t and ipsec_action_t pointers to kmc extension. Byte-
+ * aligned cur and end pointers used for bounds checking. sadb_x_kmcext_t
+ * handling encapsulated in sadb_make_kmc_ext. Returns new value for cur,
+ * NULL on failure.
+ * We encapsulate for recursion since we have to walk ipsec_action_t.
+ */
+static uint8_t *
+sadb_policy_to_kmcext(const ipsec_policy_t *pp, const ipsec_action_t *act,
+    const uint8_t *start, const uint8_t *end)
+{
+	uint8_t		*cur = (uint8_t *)start;
+	ipsec_action_t	*an, *ap = (ipsec_action_t *)act;
+	uint32_t	kmp = 0, kmc = 0;
+
+	for (; ap != NULL; ap = an) {
+		an = (pp != NULL) ? ap->ipa_next : NULL;
+
 		/*
-		 * This will happen if we fail to find a policy
-		 * allowing for IPsec processing.
-		 * Construct an error message.
+		 * Skip non-IPsec policies
 		 */
-		samsg->sadb_msg_len = SADB_8TO64(sizeof (*samsg));
-		samsg->sadb_msg_errno = ENOENT;
-		samsg->sadb_x_msg_diagnostic = 0;
-		return (mp);
+		if (ap->ipa_act.ipa_type != IPSEC_ACT_APPLY)
+			continue;
+
+		if (ap->ipa_act.ipa_apply.ipp_km_proto)
+			kmp = ap->ipa_act.ipa_apply.ipp_km_proto;
+		if (ap->ipa_act.ipa_apply.ipp_km_cookie)
+			kmc = ap->ipa_act.ipa_apply.ipp_km_cookie;
 	}
 
-	if ((kmp != 0) || (kmc != 0)) {
+	if ((kmp != 0) || (kmc != 0))
 		cur = sadb_make_kmc_ext(cur, end, kmp, kmc);
-		if (cur == NULL) {
-			freeb(mp);
-			return (NULL);
-		}
-	}
 
-	eprop->sadb_prop_len = SADB_8TO64(cur - (uint8_t *)eprop);
-	samsg->sadb_msg_len = SADB_8TO64(cur - start);
-	mp->b_wptr = cur;
-
-	return (mp);
+	return (cur);
 }
 
 /*
- * Generic setup of an RFC 2367 ACQUIRE message.  Caller sets satype.
- *
- * NOTE: This function acquires alg_lock as a side-effect if-and-only-if we
- * succeed (i.e. return non-NULL).  Caller MUST release it.  This is to
- * maximize code consolidation while preventing algorithm changes from messing
- * with the callers finishing touches on the ACQUIRE itself.
+ * Prepare the SADB_ACQUIRE message proper, which should be a b_cont to a
+ * keysock registered M_CTL message. Takes a pointer to ipsacq_t (optional
+ * acquire record for which we're sending message), ipsec_selector_t,
+ * ipsec_action_t, ipsec_policy_t, netstack_t, and sense (required for called
+ * to generate the message), and booleans for need_esp, tunnel_mode,
+ * extended, and with_prop (all of these should be self-explanatory). Because
+ * extended messages set satype to SADB_SATYPE_UNSPEC, extended-only callers
+ * can fudge need_esp.
  */
-mblk_t *
-sadb_setup_acquire(ipsacq_t *acqrec, uint8_t satype, ipsec_stack_t *ipss)
+static mblk_t *
+sadb_construct_acqmsg(ipsacq_t *acqrec, ipsec_selector_t *sel,
+    ipsec_action_t *ap, ipsec_policy_t *pp, netstack_t *ns, sadb_sens_t *sens,
+    boolean_t need_esp, boolean_t tunnel_mode, boolean_t extended,
+    boolean_t with_prop)
 {
-	uint_t allocsize;
-	mblk_t *pfkeymp, *msgmp;
-	sa_family_t af;
-	uint8_t *cur, *end;
-	sadb_msg_t *samsg;
-	uint16_t sport_typecode;
-	uint16_t dport_typecode;
-	uint8_t check_proto;
-	boolean_t tunnel_mode = (acqrec->ipsacq_inneraddrfam != 0);
+	uint_t		combs_limit, allocsize;
+	uint8_t		*cur, *end;
+	sadb_msg_t	*samsg;
+	sadb_prop_t	*prop, *eprop;
+	mblk_t		*mp;
+	int		satype = extended ? SADB_SATYPE_UNSPEC
+	    : (need_esp ? SADB_SATYPE_ESP : SADB_SATYPE_AH);
+	ipsec_stack_t	*ipss = ns->netstack_ipsec;
 
-	ASSERT(MUTEX_HELD(&acqrec->ipsacq_lock));
+	ASSERT((acqrec == NULL) || (MUTEX_HELD(&acqrec->ipsacq_lock)));
+	ASSERT(ap != NULL);
+	ASSERT((pp == NULL) || (pp->ipsp_refs != 0));
+	ASSERT((ap == NULL) || (ap->ipa_refs != 0));
 
-	pfkeymp = sadb_keysock_out(0);
-	if (pfkeymp == NULL)
-		return (NULL);
+	/*
+	 * Set the limit used to size [e]prop [e]combs array to as many
+	 * algorithms as defined on the netstack (must hold ipsec_alg_lock
+	 * from here to when done reading off netstack for [e]prop
+	 * formation). need_esp may be fudged, so be generous to extended.
+	 */
+	if (with_prop) {
+		if (extended)
+			need_esp = B_TRUE;
+		rw_enter(&ipss->ipsec_alg_lock, RW_READER);
+		CALC_COMBS(combs_limit, ipss, need_esp);
+	}
 
 	/*
-	 * First, allocate a basic ACQUIRE message
+	 * If this code is right, we may not need cur & end for bounds
+	 * checking, but we'll keep normal runtime checks until that statement
+	 * looks credible rather than merely plausible, at which point checks
+	 * can be moved to ASSERTs. sens is variably sized but already
+	 * set. kmc is fixed size. Pointers into message are byte-aligned, so
+	 * we're generally depending on all structures used in this
+	 * calculation to be so, too (in fact, all sadb_*_t types used here
+	 * are 64-bit aligned per PF_KEY requirements).
 	 */
-	allocsize = sizeof (sadb_msg_t) + sizeof (sadb_address_t) +
-	    sizeof (sadb_address_t) + sizeof (sadb_prop_t);
+	allocsize = sizeof (sadb_msg_t) + sizeof (sadb_prop_t);
+	allocsize += ((tunnel_mode) ? 4 : 2) * (sizeof (sadb_address_t)
+	    + SADB_SOCKADDR_SIZE);
+	if (sens != NULL)
+		allocsize += SADB_64TO8(sens->sadb_sens_len);
+	allocsize += sizeof (sadb_x_kmc_t);
+	/* If we need props, size combs/combs array using combs_limit */
+	if (with_prop)
+		allocsize += combs_limit * (extended ?
+		    sizeof (sadb_x_ecomb_t) : sizeof (sadb_comb_t));
 
-	/* Make sure there's enough to cover both AF_INET and AF_INET6. */
-	allocsize += 2 * sizeof (struct sockaddr_in6);
+	ASSERT((allocsize & 0x7) == 0);
 
-	mutex_enter(&ipss->ipsec_alg_lock);
-	/* NOTE:  The lock is now held through to this function's return. */
-	allocsize += ipss->ipsec_nalgs[IPSEC_ALG_AUTH] *
-	    ipss->ipsec_nalgs[IPSEC_ALG_ENCR] * sizeof (sadb_comb_t);
+	mp = allocb(allocsize, BPRI_HI);
+	if (mp == NULL)
+		goto unlock_and_fail;
 
-	if (tunnel_mode) {
-		/* Tunnel mode! */
-		allocsize += 2 * sizeof (sadb_address_t);
-		/* Enough to cover both AF_INET and AF_INET6. */
-		allocsize += 2 * sizeof (struct sockaddr_in6);
-	}
+	cur = mp->b_rptr;
+	end = cur + allocsize;
 
-	msgmp = allocb(allocsize, BPRI_HI);
-	if (msgmp == NULL) {
-		freeb(pfkeymp);
-		mutex_exit(&ipss->ipsec_alg_lock);
-		return (NULL);
+	samsg = (sadb_msg_t *)cur;
+	INITIALIZE_SAMSG(samsg, SADB_ACQUIRE);
+	samsg->sadb_msg_satype = satype;
+	samsg->sadb_msg_pid = 0;
+	samsg->sadb_msg_seq = (acqrec != NULL) ? acqrec->ipsacq_seq : 0;
+
+	/* CALC_COMBS asserts on zero limit; broken config still possible */
+	if (with_prop && (combs_limit == 0)) {
+		ERRNO_SAMSG(samsg, ENOENT);
+		goto unlock_and_bail;
 	}
 
-	pfkeymp->b_cont = msgmp;
-	cur = msgmp->b_rptr;
-	end = cur + allocsize;
-	samsg = (sadb_msg_t *)cur;
 	cur += sizeof (sadb_msg_t);
 
-	af = acqrec->ipsacq_addrfam;
-	switch (af) {
-	case AF_INET:
-		check_proto = IPPROTO_ICMP;
-		break;
-	case AF_INET6:
-		check_proto = IPPROTO_ICMPV6;
-		break;
-	default:
-		/* This should never happen unless we have kernel bugs. */
-		cmn_err(CE_WARN,
-		    "sadb_setup_acquire:  corrupt ACQUIRE record.\n");
-		ASSERT(0);
-		mutex_exit(&ipss->ipsec_alg_lock);
-		return (NULL);
-	}
+	cur = sadb_sel_to_addrexts(sel, pp, ap, cur, end, tunnel_mode);
+	if (cur == NULL)
+		goto unlock_and_fail;
 
-	samsg->sadb_msg_version = PF_KEY_V2;
-	samsg->sadb_msg_type = SADB_ACQUIRE;
-	samsg->sadb_msg_satype = satype;
-	samsg->sadb_msg_errno = 0;
-	samsg->sadb_msg_pid = 0;
-	samsg->sadb_msg_reserved = 0;
-	samsg->sadb_msg_seq = acqrec->ipsacq_seq;
+	if (with_prop) {
+		if (extended) {
+			cur = sadb_construct_eprop(ap, pp, ns, cur, end);
+			if (cur == NULL)
+				goto unlock_and_fail;
 
-	ASSERT(MUTEX_HELD(&acqrec->ipsacq_lock));
+			eprop = (sadb_prop_t *)cur;
+			if (eprop->sadb_x_prop_numecombs == 0) {
+				ERRNO_SAMSG(samsg, ENOENT);
+				goto unlock_and_bail;
+			}
+		} else {
+			prop = (sadb_prop_t *)cur;
 
-	if ((acqrec->ipsacq_proto == check_proto) || tunnel_mode) {
-		sport_typecode = dport_typecode = 0;
-	} else {
-		sport_typecode = acqrec->ipsacq_srcport;
-		dport_typecode = acqrec->ipsacq_dstport;
-	}
+			sadb_insert_prop(prop, ap, ns, combs_limit, need_esp);
+			if (prop == NULL) {
+				goto unlock_and_fail;
+			} else if (prop->sadb_prop_len == 0) {
+				ERRNO_SAMSG(samsg, ENOENT);
+				goto unlock_and_bail;
+			}
 
-	cur = sadb_make_addr_ext(cur, end, SADB_EXT_ADDRESS_SRC, af,
-	    acqrec->ipsacq_srcaddr, sport_typecode, acqrec->ipsacq_proto, 0);
+			cur += SADB_64TO8(prop->sadb_prop_len);
+		}
 
-	cur = sadb_make_addr_ext(cur, end, SADB_EXT_ADDRESS_DST, af,
-	    acqrec->ipsacq_dstaddr, dport_typecode, acqrec->ipsacq_proto, 0);
+		rw_exit(&ipss->ipsec_alg_lock);
+	}
 
-	if (tunnel_mode) {
-		sport_typecode = acqrec->ipsacq_srcport;
-		dport_typecode = acqrec->ipsacq_dstport;
-		cur = sadb_make_addr_ext(cur, end, SADB_X_EXT_ADDRESS_INNER_SRC,
-		    acqrec->ipsacq_inneraddrfam, acqrec->ipsacq_innersrc,
-		    sport_typecode, acqrec->ipsacq_inner_proto,
-		    acqrec->ipsacq_innersrcpfx);
-		cur = sadb_make_addr_ext(cur, end, SADB_X_EXT_ADDRESS_INNER_DST,
-		    acqrec->ipsacq_inneraddrfam, acqrec->ipsacq_innerdst,
-		    dport_typecode, acqrec->ipsacq_inner_proto,
-		    acqrec->ipsacq_innerdstpfx);
+	if (sens != NULL) {
+		uint8_t *sensext = cur;
+		int senslen = SADB_64TO8(sens->sadb_sens_len);
+
+		cur += senslen;
+		if (cur > end)
+			goto freeb_bail;
+		bcopy(sens, sensext, senslen);
 	}
 
-	/* XXX Insert identity information here. */
+	cur = sadb_policy_to_kmcext(pp, ap, cur, end);
+	if (cur == NULL)
+		goto freeb_bail;
 
-	/* XXXMLS Insert sensitivity information here. */
+	samsg->sadb_msg_len = SADB_8TO64(cur - mp->b_rptr);
+	mp->b_wptr = cur;
 
-	if (cur != NULL)
-		samsg->sadb_msg_len = SADB_8TO64(cur - msgmp->b_rptr);
-	else
-		mutex_exit(&ipss->ipsec_alg_lock);
+	return (mp);
 
-	return (pfkeymp);
+freeb_bail:
+	/* This message isn't chained, so we can freeb. */
+	freeb(mp);
+	return (NULL);
+unlock_and_bail:
+	if (with_prop)
+		rw_exit(&ipss->ipsec_alg_lock);
+	return (mp);
+unlock_and_fail:
+	if (with_prop)
+		rw_exit(&ipss->ipsec_alg_lock);
+	return (NULL);
 }
 
 /*
@@ -6246,6 +6500,7 @@
 
 /*
  * Fills in a reference to the policy, if any, from the conn, in *ppp
+ * If found, we hold a reference to the policy, caller must release.
  */
 static void
 ipsec_conn_pol(ipsec_selector_t *sel, conn_t *connp, ipsec_policy_t **ppp)
@@ -6253,10 +6508,12 @@
 	ipsec_policy_t	*pp;
 	ipsec_latch_t	*ipl = connp->conn_latch;
 
+	/* Use policy pointer already on conn_t if it's there. */
 	if ((ipl != NULL) && (connp->conn_ixa->ixa_ipsec_policy != NULL)) {
 		pp = connp->conn_ixa->ixa_ipsec_policy;
 		IPPOL_REFHOLD(pp);
-	} else {
+	} else { /* otherwise query SPD */
+		/* This holds a reference for us if successful) */
 		pp = ipsec_find_policy(IPSEC_TYPE_OUTBOUND, connp, sel,
 		    connp->conn_netstack);
 	}
@@ -6264,9 +6521,9 @@
 }
 
 /*
- * The following functions scan through active conn_t structures
- * and return a reference to the best-matching policy it can find.
- * Caller must release the reference.
+ * Takes ipsec_selector_t (for attributes to query), ipsec_policy_t (what we're
+ * trying to find), and ip_stack_t (contains udp fanout we need to query). If we
+ * find a matching connection, we return its policy settings.
  */
 static void
 ipsec_udp_pol(ipsec_selector_t *sel, ipsec_policy_t **ppp, ip_stack_t *ipst)
@@ -6275,6 +6532,8 @@
 	conn_t *connp = NULL;
 	ipsec_selector_t portonly;
 
+	ASSERT(*ppp == NULL);
+
 	bzero((void *)&portonly, sizeof (portonly));
 
 	if (sel->ips_local_port == 0)
@@ -6324,15 +6583,21 @@
 	CONN_DEC_REF(connp);
 }
 
+/*
+ * Takes ipsec_selector_t (connection attributes to form query) and ip_stack_t
+ * (contains bind fanout we need to query) pointers to look up existing TCP
+ * listener, returned via conn_t pointer. We return NULL on failure.
+ * We increment reference count on match, caller must decrement.
+ */
 static conn_t *
-ipsec_find_listen_conn(uint16_t *pptr, ipsec_selector_t *sel, ip_stack_t *ipst)
+ipsec_find_listen_conn(ipsec_selector_t *sel, ip_stack_t *ipst)
 {
 	connf_t *connfp;
 	conn_t *connp = NULL;
 	const in6_addr_t *v6addrmatch = &sel->ips_local_addr_v6;
 
-	if (sel->ips_local_port == 0)
-		return (NULL);
+	/* XXX Sure about the second part? */
+	ASSERT(sel->ips_local_port != 0 && ipst != NULL);
 
 	connfp = &ipst->ips_ipcl_bind_fanout[
 	    IPCL_BIND_HASH(sel->ips_local_port, ipst)];
@@ -6342,7 +6607,7 @@
 		connp = connfp->connf_head;
 		while (connp != NULL) {
 			if (IPCL_BIND_MATCH(connp, IPPROTO_TCP,
-			    sel->ips_local_addr_v4, pptr[1]))
+			    sel->ips_local_addr_v4, sel->ips_local_port))
 				break;
 			connp = connp->conn_next;
 		}
@@ -6357,7 +6622,7 @@
 		connp = connfp->connf_head;
 		while (connp != NULL) {
 			if (IPCL_BIND_MATCH_V6(connp, IPPROTO_TCP,
-			    *v6addrmatch, pptr[1]))
+			    *v6addrmatch, sel->ips_local_port))
 				break;
 			connp = connp->conn_next;
 		}
@@ -6373,6 +6638,11 @@
 	return (connp);
 }
 
+/*
+ * Given ipsec_selector_t (contains attributes to query, ipsec_policy_t (what we
+ * need to find), and ip_stack_t pointer (contains connection state to query),
+ * find a matching TCP connection or listener and return its policy pointer.
+ */
 static void
 ipsec_tcp_pol(ipsec_selector_t *sel, ipsec_policy_t **ppp, ip_stack_t *ipst)
 {
@@ -6381,9 +6651,11 @@
 	uint32_t	ports;
 	uint16_t	*pptr = (uint16_t *)&ports;
 
+	ASSERT(sel->ips_local_port != 0 && *ppp == NULL);
+
 	/*
 	 * Find TCP state in the following order:
-	 * 1.) Connected conns.
+	 * 1.) Connected conns. (walk ipst connection fanout)
 	 * 2.) Listeners.
 	 *
 	 * Even though #2 will be the common case for inbound traffic, only
@@ -6390,12 +6662,11 @@
 	 * following this order insures correctness.
 	 */
 
-	if (sel->ips_local_port == 0)
-		return;
 
 	/*
-	 * 0 should be fport, 1 should be lport.  SRC is the local one here.
-	 * See ipsec_construct_inverse_acquire() for details.
+	 * pptr makes an array of port values, 0 for fport, 1 for lport.  SRC is
+	 * the local one here. Connection lookup macros want this instead of
+	 * selector port members.
 	 */
 	pptr[0] = sel->ips_remote_port;
 	pptr[1] = sel->ips_local_port;
@@ -6429,8 +6700,8 @@
 	} else {
 		mutex_exit(&connfp->connf_lock);
 
-		/* Try the listen hash. */
-		if ((connp = ipsec_find_listen_conn(pptr, sel, ipst)) == NULL)
+		/* Try the listen hash. If found, comes with incremented ref. */
+		if ((connp = ipsec_find_listen_conn(sel, ipst)) == NULL)
 			return;
 	}
 
@@ -6438,14 +6709,20 @@
 	CONN_DEC_REF(connp);
 }
 
+/*
+ * Given ipsec_selector_t (connection attributes to form query), ipsec_policy_t
+ * (populate with match), and ip_stack_t (connection state to query) pointers,
+ * call into sctp to find an existing connection and return its policy.
+ */
 static void
-ipsec_sctp_pol(ipsec_selector_t *sel, ipsec_policy_t **ppp,
-    ip_stack_t *ipst)
+ipsec_sctp_pol(ipsec_selector_t *sel, ipsec_policy_t **ppp, ip_stack_t *ipst)
 {
 	conn_t		*connp;
 	uint32_t	ports;
 	uint16_t	*pptr = (uint16_t *)&ports;
 
+	ASSERT(sel->ips_local_port != 0 && *ppp == NULL);
+
 	/*
 	 * Find SCP state in the following order:
 	 * 1.) Connected conns.
@@ -6455,12 +6732,10 @@
 	 * following this order insures correctness.
 	 */
 
-	if (sel->ips_local_port == 0)
-		return;
-
 	/*
-	 * 0 should be fport, 1 should be lport.  SRC is the local one here.
-	 * See ipsec_construct_inverse_acquire() for details.
+	 * pptr makes an array of port values, 0 for fport, 1 for lport.  SRC is
+	 * the local one here. Connection lookup macros want this instead of
+	 * selector port members.
 	 */
 	pptr[0] = sel->ips_remote_port;
 	pptr[1] = sel->ips_local_port;
@@ -6489,10 +6764,9 @@
 }
 
 /*
- * Fill in a query for the SPD (in "sel") using two PF_KEY address extensions.
- * Returns 0 or errno, and always sets *diagnostic to something appropriate
- * to PF_KEY.
- *
+ * Takes ipsec_selector_t (what we're forming), two sadb_address_t (address
+ * extentions needed to create selector), and diagnostic (what, if anything,
+ * went wrong in PF_KEY terms) pointers, returns int (0 or errno).
  * NOTE:  For right now, this function (and ipsec_selector_t for that matter),
  * ignore prefix lengths in the address extension.  Since we match on first-
  * entered policies, this shouldn't matter.  Also, since we normalize prefix-
@@ -6548,15 +6822,13 @@
 }
 
 /*
- * We have encapsulation.
- * - Lookup tun_t by address and look for an associated
- *   tunnel policy
- * - If there are inner selectors
- *   - check ITPF_P_TUNNEL and ITPF_P_ACTIVE
- *   - Look up tunnel policy based on selectors
- * - Else
- *   - Sanity check the negotation
- *   - If appropriate, fall through to global policy
+ * We're passed pointers to ipsec_selector (inner info needed to form query),
+ * ipsec_policy_t (what we're trying to populate), a pair of sadb_address_t
+ * (extentions needed to reset selector), ipsec_tun_pol_t (tunnel policy that
+ * may already be populated from previous SPD query), and integer (error detail
+ * in PF_KEY2 terms, always 0). Return 0 or errno.
+ * Caller may have fudged inner selector, so we need to reset it via if we have
+ * to reuse it.
  */
 static int
 ipsec_tun_pol(ipsec_selector_t *sel, ipsec_policy_t **ppp,
@@ -6566,44 +6838,38 @@
 	int err;
 	ipsec_policy_head_t *polhead;
 
+	ASSERT(*ppp == NULL);
+
 	*diagnostic = 0;
 
 	/* Check for inner selectors and act appropriately */
-
 	if (innsrcext != NULL) {
-		/* Inner selectors present */
-		ASSERT(inndstext != NULL);
+		ASSERT(inndstext != NULL); /* Need a pair */
+		/*
+		 * If inner packet selectors, we must have negotiated tunnel and
+		 * active policy already. If the tunnel has transport-mode
+		 * policy set on it or no policy at all, fail.
+		 */
 		if ((itp == NULL) ||
 		    (itp->itp_flags & (ITPF_P_ACTIVE | ITPF_P_TUNNEL)) !=
 		    (ITPF_P_ACTIVE | ITPF_P_TUNNEL)) {
-			/*
-			 * If inner packet selectors, we must have negotiate
-			 * tunnel and active policy.  If the tunnel has
-			 * transport-mode policy set on it, or has no policy,
-			 * fail.
-			 */
 			return (ENOENT);
 		} else {
 			/*
-			 * Reset "sel" to indicate inner selectors.  Pass
-			 * inner PF_KEY address extensions for this to happen.
+			 * If we got a sane policy back from the SPD, reset the
+			 * possibly fudged selector for subsequent operations.
 			 */
 			if ((err = ipsec_get_inverse_acquire_sel(sel,
-			    innsrcext, inndstext, diagnostic)) != 0)
+				    innsrcext, inndstext, diagnostic)) != 0)
 				return (err);
-			/*
-			 * Now look for a tunnel policy based on those inner
-			 * selectors.  (Common code is below.)
-			 */
 		}
-	} else {
-		/* No inner selectors present */
+	} else { /* No inner selectors present */
+
+		/*
+		 * Transport mode negotiation with no tunnel policy configured
+		 * - return to indicate a global policy check is needed.
+		 */
 		if ((itp == NULL) || !(itp->itp_flags & ITPF_P_ACTIVE)) {
-			/*
-			 * Transport mode negotiation with no tunnel policy
-			 * configured - return to indicate a global policy
-			 * check is needed.
-			 */
 			return (0);
 		} else if (itp->itp_flags & ITPF_P_TUNNEL) {
 			/* Tunnel mode set with no inner selectors. */
